DOTNETARX(一個用於.net開發AutoCAD程序的類庫)實例教學(續)

 

本來已寫好中文的,但不知怎麼搞的,給弄丟了。先把英文的給發上來,等過段時間我再發中文的。

The following functions is provieded in DOTNETARX 2.1.

  • AddBlockTableRecord

In DOTNETARX,you can add the symbol table record using the AddSymbolTableRecord() function.But the BlockTableRecord is different from the other symbol table records.So,you must use the AddBlockTableRecord() function to add the BlockTableRecord.AddBlockTableRecord() function has two forms.The first one takes the Entity array as its argument (which represents the entities that have not added into the AutoCAD database).If you want to add the entities on the screen into the Block Table Record,you will have to use the second one.It takes the ObjectId of the entities as its argument.

 The following example show you how to use AddBlockTableRecord() to create Block Table Records.     

    void Test()
    {
        Lines line=new Lines(new Point3d(0,0,0),new Point3d(50,50,0));
        Circles circle=new Circles(new Point3d(50,50,0),25);
        BlockTableRecord btr1=new BlockTableRecord();//Creates a new block table record named block1
        btr1.Name="block1";
        btr1.Origin=circle.Center;
        Tools.AddBlockTableRecord(btr1,new Entity[]{line,circle});
        //Adds the line and circle to block1,then adds block1 to the block table of AutoCAD database.

        PromptSelectionResult res=Tools.Editor.GetSelection();//Selects objects on the screen.
        ObjectIdCollection ids=new ObjectIdCollection(res.Value.GetObjectIds());
        //Gets the ObjectIds of the Selected objects.
        BlockTableRecord btr2=new BlockTableRecord();//Creates a new block table record named block2
        btr2.Name="block2";
        btr2.Origin=new Point3d(0,0,0);
        Tools.AddBlockTableRecord(btr2,ids);
        //Adds the selected objects to block2,then adds block2 to the block table of AutoCAD database.
    }
  •  CoordFromPixelToWorld() and CoordFromWorldToPixel()
There's no first class .NET API to convert pixel to world coordinates and back.Special thanks to Albert Szilvasy on Autodesk discussion group providing the way to solve this problem. The following example shows you how to use CoordFromPixelToWorld() and CoordFromWorldToPixel() function to convert pixel to world coordinates and back. Note:Inorder to use the two functions,you must add the System.Drawing.dll assembly to your project.    
    void Test()
    {
        Editor ed=Tools.Editor;
        Point3d pt1=ed.GetPoint("/nPlease select a point:").Value;
        System.Drawing.Point pix1;//You must add the System.Drawing.dll in the reference of your project.
        Tools.CoordFromWorldToPixel(0,ref pt1,out pix1);
        ed.WriteMessage("/npixel coordinate is"+pix1.ToString()+",world coordinate is"+pt1.ToString());

        System.Drawing.Point pix2=new System.Drawing.Point(100,100);
        Point3d pt2;
        Tools.CoordFromPixelToWorld(0,pix2,out pt2);
        ed.WriteMessage("/npixel coordinate is"+pix2.ToString()+",world coordinate is"+pt2.ToString());
    }
  • GetBoundingBox()
In the .NET API,the GeomExtents property of an entity can get the corner points of a box that encloses the 3D extents of the entity.But for DBText and MText,the GeomExtents property always returns the point (0,0,0) for the minpoint of the box.So,DOTNETARX provides the GetBoundingBox() function to let you get the correct corner points of an entity including the DBText and the MText object.The return value of GetBoundingBox() is a Point3d array,[0] is the minimum point of the object's bounding box,[1] is the maximum point of the object's bounding box. The following example shows you how to use GetBoundingBox().      
    void Test()
    {
        Editor ed=Tools.Editor;
        ObjectId id=ed.GetEntity("Please select an entity on the screen:/n").ObjectId;
        //Gets the ObjectId of a selected entity.
        Point3d[] pts=Tools.GetBoundingBox(id);//Gets the the two points of a box enclosing the selected entity.
        Lines line=new Lines(pts[0],pts[1]);//Creates a line to see the output.
        Tools.AddEntity(line);
    }
  • Sendcommand and Regen

Sendcommand() function sends a command string to the current document for processing.
There is no Regen function in .NET API,so I add the Regen() function in DOTNETARX.
The following example sends a command for evaluation to the AutoCAD command line of a particular drawing. Create a Circle in the active drawing and zoom to display the entire circle.     

    void Test()
    {
        Tools.SendCommand("_Circle","2,2,0","4");//You don't need the character "/n" for the Return action.
        Tools.SendCommand("_zoom","a");
        Tools.Regen(Tools.RegenType.AllViewPorts);//Refresh view
    }
發表評論
所有評論
還沒有人評論,想成為第一個評論的人麼? 請在上方評論欄輸入並且點擊發布.
相關文章